<?php
//Based on HTML2PDF by Clément Lavoillotte

require('../fpdf/fpdf.php');

//function hex2dec
//returns an associative array (keys: R,G,B) from
//a hex html code (e.g. #3FE5AA)
function hex2dec($couleur = "#000000"){
	$R = substr($couleur, 1, 2);
	$rouge = hexdec($R);
	$V = substr($couleur, 3, 2);
	$vert = hexdec($V);
	$B = substr($couleur, 5, 2);
	$bleu = hexdec($B);
	$tbl_couleur = array();
	$tbl_couleur['R']=$rouge;
	$tbl_couleur['G']=$vert;
	$tbl_couleur['B']=$bleu;
	return $tbl_couleur;
}

//conversion pixel -> millimeter in 72 dpi
function px2mm($px){
	return $px*25.4/72;
}

function txtentities($html){
	$trans = get_html_translation_table(HTML_ENTITIES);
	$trans = array_flip($trans);
	return strtr($html, $trans);
}
////////////////////////////////////

class PDF extends FPDF
{
//variables of html parser
var $B;
var $I;
var $U;
var $HREF;
var $fontList;
var $issetfont;
var $issetcolor;

function PDF($orientation='P', $unit='mm', $format='A4')
{
	//Call parent constructor
	$this->FPDF($orientation,$unit,$format);
	//Initialization
	$this->B=0;
	$this->I=0;
	$this->U=0;
	$this->HREF='';

	$this->tableborder=0;
	$this->tdbegin=false;
	$this->tdwidth=0;
	$this->tdheight=0;
	$this->tdalign="L";
	$this->tdbgcolor=false;

	$this->oldx=0;
	$this->oldy=0;

	$this->fontlist=array("arial","times","courier","helvetica","symbol");
	$this->issetfont=false;
	$this->issetcolor=false;
}

//////////////////////////////////////
//html parser

function WriteHTML($html)
{
	$html=strip_tags($html,"<b><u><i><a><img><p><br><strong><em><font><tr><blockquote><hr><td><tr><table><sup>"); //remove all unsupported tags
	$html=str_replace("\n",'',$html); //replace carriage returns by spaces
	$html=str_replace("\t",'',$html); //replace carriage returns by spaces
	$a=preg_split('/<(.*)>/U',$html,-1,PREG_SPLIT_DELIM_CAPTURE); //explodes the string
	foreach($a as $i=>$e)
	{
		if($i%2==0)
		{
			//Text
			if($this->HREF)
				$this->PutLink($this->HREF,$e);
			elseif($this->tdbegin) {
				if(trim($e)!='' && $e!="&nbsp;") {
					$this->Cell($this->tdwidth,$this->tdheight,$e,$this->tableborder,'',$this->tdalign,$this->tdbgcolor);
				}
				elseif($e=="&nbsp;") {
					$this->Cell($this->tdwidth,$this->tdheight,'',$this->tableborder,'',$this->tdalign,$this->tdbgcolor);
				}
			}
			else
				$this->Write(5,stripslashes(txtentities($e)));
		}
		else
		{
			//Tag
			if($e[0]=='/')
				$this->CloseTag(strtoupper(substr($e,1)));
			else
			{
				//Extract attributes
				$a2=explode(' ',$e);
				$tag=strtoupper(array_shift($a2));
				$attr=array();
				foreach($a2 as $v)
				{
					if(preg_match('/([^=]*)=["\']?([^"\']*)/',$v,$a3))
						$attr[strtoupper($a3[1])]=$a3[2];
				}
				$this->OpenTag($tag,$attr);
			}
		}
	}
}

function OpenTag($tag, $attr)
{
	//Opening tag
	switch($tag){

		case 'SUP':
			if( !empty($attr['SUP']) ) {	
				//Set current font to 6pt 	
				$this->SetFont('','',6);
				//Start 125cm plus width of cell to the right of left margin 		
				//Superscript "1" 
				$this->Cell(2,2,$attr['SUP'],0,0,'L');
			}
			break;

		case 'TABLE': // TABLE-BEGIN
			if( !empty($attr['BORDER']) ) $this->tableborder=$attr['BORDER'];
			else $this->tableborder=0;
			break;
		case 'TR': //TR-BEGIN
			break;
		case 'TD': // TD-BEGIN
			if( !empty($attr['WIDTH']) ) $this->tdwidth=($attr['WIDTH']/4);
			else $this->tdwidth=40; // Set to your own width if you need bigger fixed cells
			if( !empty($attr['HEIGHT']) ) $this->tdheight=($attr['HEIGHT']/6);
			else $this->tdheight=6; // Set to your own height if you need bigger fixed cells
			if( !empty($attr['ALIGN']) ) {
				$align=$attr['ALIGN'];		
				if($align=='LEFT') $this->tdalign='L';
				if($align=='CENTER') $this->tdalign='C';
				if($align=='RIGHT') $this->tdalign='R';
			}
			else $this->tdalign='L'; // Set to your own
			if( !empty($attr['BGCOLOR']) ) {
				$coul=hex2dec($attr['BGCOLOR']);
					$this->SetFillColor($coul['R'],$coul['G'],$coul['B']);
					$this->tdbgcolor=true;
				}
			$this->tdbegin=true;
			break;

		case 'HR':
			if( !empty($attr['WIDTH']) )
				$Width = $attr['WIDTH'];
			else
				$Width = $this->w - $this->lMargin-$this->rMargin;
			$x = $this->GetX();
			$y = $this->GetY();
			$this->SetLineWidth(0.2);
			$this->Line($x,$y,$x+$Width,$y);
			$this->SetLineWidth(0.2);
			$this->Ln(1);
			break;
		case 'STRONG':
			$this->SetStyle('B',true);
			break;
		case 'EM':
			$this->SetStyle('I',true);
			break;
		case 'B':
		case 'I':
		case 'U':
			$this->SetStyle($tag,true);
			break;
		case 'A':
			$this->HREF=$attr['HREF'];
			break;
		case 'IMG':
			if(isset($attr['SRC']) && (isset($attr['WIDTH']) || isset($attr['HEIGHT']))) {
				if(!isset($attr['WIDTH']))
					$attr['WIDTH'] = 0;
				if(!isset($attr['HEIGHT']))
					$attr['HEIGHT'] = 0;
				$this->Image($attr['SRC'], $this->GetX(), $this->GetY(), px2mm($attr['WIDTH']), px2mm($attr['HEIGHT']));
			}
			break;
		case 'BLOCKQUOTE':
		case 'BR':
			$this->Ln(5);
			break;
		case 'P':
			$this->Ln(10);
			break;
		case 'FONT':
			if (isset($attr['COLOR']) && $attr['COLOR']!='') {
				$coul=hex2dec($attr['COLOR']);
				$this->SetTextColor($coul['R'],$coul['G'],$coul['B']);
				$this->issetcolor=true;
			}
			if (isset($attr['FACE']) && in_array(strtolower($attr['FACE']), $this->fontlist)) {
				$this->SetFont(strtolower($attr['FACE']));
				$this->issetfont=true;
			}
			if (isset($attr['FACE']) && in_array(strtolower($attr['FACE']), $this->fontlist) && isset($attr['SIZE']) && $attr['SIZE']!='') {
				$this->SetFont(strtolower($attr['FACE']),'',$attr['SIZE']);
				$this->issetfont=true;
			}
			break;
	}
}

function CloseTag($tag)
{
	//Closing tag
	if($tag=='SUP') {
	}

	if($tag=='TD') { // TD-END
		$this->tdbegin=false;
		$this->tdwidth=0;
		$this->tdheight=0;
		$this->tdalign="L";
		$this->tdbgcolor=false;
	}
	if($tag=='TR') { // TR-END
		$this->Ln();
	}
	if($tag=='TABLE') { // TABLE-END
		//$this->Ln();
		$this->tableborder=0;
	}

	if($tag=='STRONG')
		$tag='B';
	if($tag=='EM')
		$tag='I';
	if($tag=='B' || $tag=='I' || $tag=='U')
		$this->SetStyle($tag,false);
	if($tag=='A')
		$this->HREF='';
	if($tag=='FONT'){
		if ($this->issetcolor==true) {
			$this->SetTextColor(0);
		}
		if ($this->issetfont) {
			$this->SetFont('arial');
			$this->issetfont=false;
		}
	}
}

function SetStyle($tag, $enable)
{
	//Modify style and select corresponding font
	$this->$tag+=($enable ? 1 : -1);
	$style='';
	foreach(array('B','I','U') as $s) {
		if($this->$s>0)
			$style.=$s;
	}
	$this->SetFont('',$style);
}

function PutLink($URL, $txt)
{
	//Put a hyperlink
	$this->SetTextColor(0,0,255);
	$this->SetStyle('U',true);
	$this->Write(5,$txt,$URL);
	$this->SetStyle('U',false);
	$this->SetTextColor(0);
}



function _parsebmp ($file){
    $fsize = filesize($file);
    $f = fopen($file, 'rb');

    # bmpfileheader (0..13)
    $bfOffBits = $this->_fread_long_le_at($f, 10);

    # bmpinfoheader (14..53)
    $width    = $this->_fread_long_le_at($f, 18);
    $height = $this->_fread_long_le_at($f,22);
    $flip = ($height<0);
    if ($flip) $height =-$height;
    $biBitCount    = $this->_fread_short_le_at($f, 28);
    $biCompression = $this->_fread_long_le_at($f, 30); # BI_RGB = 0, BI_RLE8 = 1, BI_RLE4 = 2

    $info = array('w'=>$width, 'h'=>$height);

    fseek($f, 54);

    if ($biBitCount<16){
        $info['cs'] = 'Indexed';
        $info['bpc'] = $biBitCount;
        $palStr = fread($f, $bfOffBits-54); # palette
        $pal = '';
        $cnt = strlen($palStr)/4;
        for ($i=0;$i<$cnt;$i++){
            $n = 4*$i;
            $pal .= $palStr{$n+2}.$palStr{$n+1}.$palStr{$n};
        }
        $info['pal'] = $pal;
    }else{
        $info['cs'] = 'DeviceRGB';
        $info['bpc'] = 8;
    }

    # image data
    switch ($biCompression){
        case 0:
            $str = fread($f, $fsize-$bfOffBits);
            break;
        case 1: # BI_RLE8
            $str = $this->rle8_decode(fread($f, $fsize-$bfOffBits), $width);
            break;
        case 2: # BI_RLE4
            $str = $this->rle4_decode(fread($f, $fsize-$bfOffBits), $width);
            break;
    }

    $data = '';
    $padCnt = (4-ceil(($width/(8/$biBitCount)))%4)%4;

    switch ($biBitCount){
        case 1:
        case 4:
        case 8:
            $w = floor($width/(8/$biBitCount)) + ($width%(8/$biBitCount)?1:0);
            $w_row = $w + $padCnt;
            if ($flip){
                for ($y=0;$y<$height;$y++){
                    $y0 = $y*$w_row;
                    for ($x=0;$x<$w;$x++)
                        $data .= $str{$y0+$x};
                }
            }else{
                for ($y=$height-1;$y>=0;$y--){
                    $y0 = $y*$w_row;
                    for ($x=0;$x<$w;$x++)
                        $data .= $str{$y0+$x};
                }
            }
            break;

        case 16:
            $w_row = $width*2 + $padCnt;
            if ($flip){
                for ($y=0;$y<$height;$y++){
                    $y0 = $y*$w_row;
                    for ($x=0;$x<$width;$x++){
                        $n = (ord( $str{$y0 + 2*$x + 1})*256 +    ord( $str{$y0 + 2*$x}));
                        $b = ($n & 31)<<3; $g = ($n & 992)>>2; $r = ($n & 31744)>>7128;
                        $data .= chr($r) . chr($g) . chr($b);
                    }
                }
             }else{
                for ($y=$height-1;$y>=0;$y--){
                    $y0 = $y*$w_row;
                    for ($x=0;$x<$width;$x++){
                        $n = (ord( $str{$y0 + 2*$x + 1})*256 +    ord( $str{$y0 + 2*$x}));
                        $b = ($n & 31)<<3; $g = ($n & 992)>>2; $r = ($n & 31744)>>7;
                        $data .= chr($r) . chr($g) . chr($b);
                    }
                }
            }
            break;

        case 24:
        case 32:
            ##$padCnt = $width % 4;
            $byteCnt = $biBitCount/8;
            $w_row = $width*$byteCnt + $padCnt;

            if ($flip){
                for ($y=0;$y<$height;$y++){
                    $y0 = $y*$w_row;
                    for ($x=0;$x<$width;$x++){
                        $i = $y0 + $x*$byteCnt ; # + 1
                        $data .= $str{$i+2}.$str{$i+1}.$str{$i};
                    }
                }
            }else{
                for ($y=$height-1;$y>=0;$y--){
                    $y0 = $y*$w_row;
                    for ($x=0;$x<$width;$x++){
                        $i = $y0 + $x*$byteCnt ; # + 1
                        $data .= $str{$i+2}.$str{$i+1}.$str{$i};
                    }
                }
            }
            break;

        default:
            $this->Error('Unsupported image biBitCount: '.$file);
    }

    # compress data
    $info['f'] = 'FlateDecode';
    $info['data'] = gzcompress($data);
    return $info;
}


function _fread_long_le_at($f, $pos){
    fseek($f, $pos);
    $a=unpack('Vi', fread($f,4));
    return $a['i'];
}

function _fread_short_le_at($f, $pos){
    fseek($f, $pos);
    $a=unpack('vi', fread($f,2));
    return $a['i'];
}

# Decoder for RLE8 compression in windows bitmaps
# see http://msdn.microsoft.com/library/default.asp?url=/library/en-us/gdi/bitmaps_6x0u.asp
function rle8_decode ($str, $width){
    $lineWidth = $width + (3 - ($width-1) % 4);
    $out = '';
    $cnt = strlen($str);
    for ($i=0;$i<$cnt;$i++){
        $o = ord($str{$i});
        switch ($o){
            case 0: # ESCAPE
                $i++;
                switch (ord($str{$i})){
                    case 0: # NEW LINE
                         $padCnt = $lineWidth - strlen($out)%$lineWidth;
                        if ($padCnt<$lineWidth) $out .= str_repeat(chr(0), $padCnt); # pad line
                        break;
                    case 1: # END OF FILE
                        $padCnt = $lineWidth - strlen($out)%$lineWidth;
                        if ($padCnt<$lineWidth) $out .= str_repeat(chr(0), $padCnt); # pad line
                         break 3;
                    case 2: # DELTA
                        $i += 2;
                        break;
                    default: # ABSOLUTE MODE
                        $num = ord($str{$i});
                        for ($j=0;$j<$num;$j++)
                            $out .= $str{++$i};
                        if ($num % 2) $i++;
             }
                break;
            default:
                $out .= str_repeat($str{++$i}, $o);
        }
    }
    return $out;
}

# Decoder for RLE4 compression in windows bitmaps
# see http://msdn.microsoft.com/library/default.asp?url=/library/en-us/gdi/bitmaps_6x0u.asp
function rle4_decode ($str, $width){
    $w = floor($width/2) + ($width % 2);
    $lineWidth = $w + (3 - ( ($width-1) / 2) % 4);
    $pixels = array();
    $cnt = strlen($str);
    for ($i=0;$i<$cnt;$i++){
        $o = ord($str{$i});
        switch ($o){
            case 0: # ESCAPE
                $i++;
                switch (ord($str{$i})){
                    case 0: # NEW LINE
                        while (count($pixels)%$lineWidth!=0)
                            $pixels[]=0;
                        break;
                    case 1: # END OF FILE
                        while (count($pixels)%$lineWidth!=0)
                            $pixels[]=0;
                        break 3;
                    case 2: # DELTA
                        $i += 2;
                        break;
                    default: # ABSOLUTE MODE
                        $num = ord($str{$i});
                        for ($j=0;$j<$num;$j++){
                            if ($j%2==0){
                                $c = ord($str{++$i});
                              $pixels[] = ($c & 240)>>4;
                             } else
                              $pixels[] = $c & 15;
                        }
                        if ($num % 2) $i++;
             }
                break;
            default:
                $c = ord($str{++$i});
                for ($j=0;$j<$o;$j++)
                    $pixels[] = ($j%2==0 ? ($c & 240)>>4 : $c & 15);
        }
    }

    $out = '';
    if (count($pixels)%2) $pixels[]=0;
    $cnt = count($pixels)/2;
    for ($i=0;$i<$cnt;$i++)
        $out .= chr(16*$pixels[2*$i] + $pixels[2*$i+1]);
    return $out;
} 

}//end of class

?>
